<template>
  <div class="category-page">
    <div class="category-card-wrapper">
      <CategoryCard :category="currentCategory" />
    </div>
    <hr />
    <div class="category-image-wrapper">
      <ProductCard
        v-for="product in currentProducts"
        :key="product.id"
        :product="product && product"
      />
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions, mapMutations } from "vuex";
import ProductCard from "@/components/ProductCard.vue";
import CategoryCard from "@/components/CategoryCard.vue";
export default {
  name: "CategoryView",
  components: {
    ProductCard,
    CategoryCard,
  },
  computed: {
    ...mapGetters(["getProducts", "getCategories"]),
    products() {
      return this.getProducts;
    },
    categories() {
      return this.getCategories;
    },

    currentProducts() {
      return this.products?.filter((p) =>
        p.categoryIds.includes(Number(this.$route.params.id))
      );
    },
    currentCategory() {
      return this.categories?.find(
        (p) => p.id === Number(this.$route.params.id)
      );
    },
  },

  async mounted() {
    await this.loadProducts();
    await this.loadCategories();
  },

  methods: {
    ...mapMutations(["updateCartCount"]),
    ...mapActions(["fetchProducts", "fetchCategories"]),

    loadProducts() {
      this.fetchProducts();
    },
    loadCategories() {
      this.fetchCategories();
    },
  },
};
</script>

<style scoped>
.category-page {
  padding: 5% 10%;
}
.category-card-wrapper {
  margin-bottom: 32px;
}

.category-image-wrapper {
  margin-top: 32px;
  display: flex;
  flex-wrap: wrap;
}
</style>
